MAKEALL 22.7 KB
Newer Older
Peter Tyser's avatar
Peter Tyser committed
1
#!/bin/bash
2 3 4
# Tool mainly for U-Boot Quality Assurance: build one or more board
# configurations with minimal verbosity, showing only warnings and
# errors.
5 6
#
# SPDX-License-Identifier:	GPL-2.0+
7

8 9 10 11 12 13 14 15 16 17 18 19 20
usage()
{
	# if exiting with 0, write to stdout, else write to stderr
	local ret=${1:-0}
	[ "${ret}" -eq 1 ] && exec 1>&2
	cat <<-EOF
	Usage: MAKEALL [options] [--] [boards-to-build]

	Options:
	  -a ARCH,   --arch ARCH       Build all boards with arch ARCH
	  -c CPU,    --cpu CPU         Build all boards with cpu CPU
	  -v VENDOR, --vendor VENDOR   Build all boards with vendor VENDOR
	  -s SOC,    --soc SOC         Build all boards with soc SOC
21
	  -b BOARD,  --board BOARD     Build all boards with board name BOARD
22
	  -l,        --list            List all targets to be built
23 24
	  -m,        --maintainers     List all targets and maintainer email
	  -M,        --mails           List all targets and all affilated emails
25
	  -C,        --check           Enable build checking
26 27
	  -n,        --continue        Continue (skip boards already built)
	  -r,        --rebuild-errors  Rebuild any boards that errored
28 29 30 31 32 33 34 35 36 37 38 39 40
	  -h,        --help            This help output

	Selections by these options are logically ANDed; if the same option
	is used repeatedly, such selections are ORed.  So "-v FOO -v BAR"
	will select all configurations where the vendor is either FOO or
	BAR.  Any additional arguments specified on the command line are
	always build additionally.  See the boards.cfg file for more info.

	If no boards are specified, then the default is "powerpc".

	Environment variables:
	  BUILD_NCPUS      number of parallel make jobs (default: auto)
	  CROSS_COMPILE    cross-compiler toolchain prefix (default: "")
41
	  CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 43
			   architecture "ARCH".  Substitute "ARCH" for any
			   supported architecture (default: "")
44 45
	  MAKEALL_LOGDIR   output all logs to here (default: ./LOG/)
	  BUILD_DIR        output build directory (default: ./)
46
	  BUILD_NBUILDS	   number of parallel targets (default: 1)
47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62

	Examples:
	  - build all Power Architecture boards:
	      MAKEALL -a powerpc
	      MAKEALL --arch powerpc
	      MAKEALL powerpc
	  - build all PowerPC boards manufactured by vendor "esd":
	      MAKEALL -a powerpc -v esd
	  - build all PowerPC boards manufactured either by "keymile" or "siemens":
	      MAKEALL -a powerpc -v keymile -v siemens
	  - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
	      MAKEALL -c mpc83xx -v freescale 4xx
	EOF
	exit ${ret}
}

Simon Glass's avatar
Simon Glass committed
63 64 65 66 67 68 69 70
deprecation() {
	echo "** Note: MAKEALL is deprecated - please use buildman instead"
	echo "** See tools/buildman/README for details"
	echo
}

deprecation

71 72
SHORT_OPTS="ha:c:v:s:b:lmMCnr"
LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
73 74 75

# Option processing based on util-linux-2.13/getopt-parse.bash

Wolfgang Denk's avatar
Wolfgang Denk committed
76
# Note that we use `"$@"' to let each command-line parameter expand to a
77 78 79 80 81 82
# separate word. The quotes around `$@' are essential!
# We need TEMP as the `eval set --' would nuke the return value of
# getopt.
TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
     -n 'MAKEALL' -- "$@"`

83
[ $? != 0 ] && usage 1
84 85 86 87 88

# Note the quotes around `$TEMP': they are essential!
eval set -- "$TEMP"

SELECTED=''
89
ONLY_LIST=''
90 91
PRINT_MAINTS=''
MAINTAINERS_ONLY=''
92 93
CONTINUE=''
REBUILD_ERRORS=''
94 95 96 97 98 99 100 101 102 103 104 105 106 107 108

while true ; do
	case "$1" in
	-a|--arch)
		# echo "Option ARCH: argument \`$2'"
		if [ "$opt_a" ] ; then
			opt_a="${opt_a%)} || \$2 == \"$2\")"
		else
			opt_a="(\$2 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
	-c|--cpu)
		# echo "Option CPU: argument \`$2'"
		if [ "$opt_c" ] ; then
109
			opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
110
		else
111
			opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
112 113 114 115 116 117
		fi
		SELECTED='y'
		shift 2 ;;
	-s|--soc)
		# echo "Option SoC: argument \`$2'"
		if [ "$opt_s" ] ; then
118
			opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
119
		else
120
			opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
121 122 123 124 125 126 127 128 129 130 131 132
		fi
		SELECTED='y'
		shift 2 ;;
	-v|--vendor)
		# echo "Option VENDOR: argument \`$2'"
		if [ "$opt_v" ] ; then
			opt_v="${opt_v%)} || \$5 == \"$2\")"
		else
			opt_v="(\$5 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
133 134 135 136 137 138 139 140 141 142 143
	-b|--board)
		# echo "Option BOARD: argument \`$2'"
		if [ "$opt_b" ] ; then
			opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
		else
			# We need to check the 7th field too
			# for boards whose 6th field is "-"
			opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
144 145 146
	-C|--check)
		CHECK='C=1'
		shift ;;
147 148 149 150 151 152
	-n|--continue)
		CONTINUE='y'
		shift ;;
	-r|--rebuild-errors)
		REBUILD_ERRORS='y'
		shift ;;
153 154 155
	-l|--list)
		ONLY_LIST='y'
		shift ;;
156 157 158 159 160 161 162 163 164
	-m|--maintainers)
		ONLY_LIST='y'
		PRINT_MAINTS='y'
		MAINTAINERS_ONLY='y'
		shift ;;
	-M|--mails)
		ONLY_LIST='y'
		PRINT_MAINTS='y'
		shift ;;
165 166
	-h|--help)
		usage ;;
167 168 169 170 171 172
	--)
		shift ; break ;;
	*)
		echo "Internal error!" >&2 ; exit 1 ;;
	esac
done
173 174 175 176 177 178

GNU_MAKE=$(scripts/show-gnu-make) || {
	echo "GNU Make not found" >&2
	exit 1
}

179 180 181
# echo "Remaining arguments:"
# for arg do echo '--> '"\`$arg'" ; done

182 183 184 185
tools/genboardscfg.py || {
	echo "Failed to generate boards.cfg" >&2
	exit 1
}
186

187 188 189 190 191
FILTER="\$1 !~ /^#/"
[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
192
[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
193 194

if [ "$SELECTED" ] ; then
195
	SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
196 197 198 199 200 201

	# Make sure some boards from boards.cfg are actually found
	if [ -z "$SELECTED" ] ; then
		echo "Error: No boards selected, invalid arguments"
		exit 1
	fi
202 203 204 205
fi

#########################################################################

206 207 208 209
# Print statistics when we exit
trap exit 1 2 3 15
trap print_stats 0

210 211 212 213 214
# Determine number of CPU cores if no default was set
: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}

if [ "$BUILD_NCPUS" -gt 1 ]
then
Peter Tyser's avatar
Peter Tyser committed
215
	JOBS="-j $((BUILD_NCPUS + 1))"
216 217 218 219
else
	JOBS=""
fi

220 221 222 223 224
if [ "${MAKEALL_LOGDIR}" ] ; then
	LOG_DIR=${MAKEALL_LOGDIR}
else
	LOG_DIR="LOG"
fi
225

226 227 228 229 230 231 232 233
: ${BUILD_NBUILDS:=1}
BUILD_MANY=0

if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
	BUILD_MANY=1
	: ${BUILD_DIR:=./build}
	mkdir -p "${BUILD_DIR}/ERR"
	find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
234 235
fi

236 237 238 239 240
: ${BUILD_DIR:=.}

OUTPUT_PREFIX="${BUILD_DIR}"

[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
241 242 243
if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
	find "${LOG_DIR}/" -type f -exec rm -f {} +
fi
wdenk's avatar
wdenk committed
244 245 246

LIST=""

247 248 249
# Keep track of the number of builds and errors
ERR_CNT=0
ERR_LIST=""
250 251
WRN_CNT=0
WRN_LIST=""
252
TOTAL_CNT=0
253
SKIP_CNT=0
254 255
CURRENT_CNT=0
OLDEST_IDX=1
Peter Tyser's avatar
Peter Tyser committed
256
RC=0
257

258
# Helper funcs for parsing boards.cfg
259
targets_by_field()
260
{
261 262 263 264 265
	field=$1
	regexp=$2

	awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
								boards.cfg
266
}
267

268 269 270
targets_by_arch() { targets_by_field 2 "$@" ; }
targets_by_cpu()  { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
targets_by_soc()  { targets_by_field 4 "$@" ; }
271

272 273 274 275
#########################################################################
## MPC5xx Systems
#########################################################################

276
LIST_5xx="$(targets_by_cpu mpc5xx)"
277

278 279 280 281
#########################################################################
## MPC5xxx Systems
#########################################################################

282
LIST_5xxx="$(targets_by_cpu mpc5xxx)"
283

284 285 286 287
#########################################################################
## MPC512x Systems
#########################################################################

288
LIST_512x="$(targets_by_cpu mpc512x)"
289

wdenk's avatar
wdenk committed
290 291 292
#########################################################################
## MPC8xx Systems
#########################################################################
293

294
LIST_8xx="$(targets_by_cpu mpc8xx)"
wdenk's avatar
wdenk committed
295 296 297 298 299

#########################################################################
## PPC4xx Systems
#########################################################################

300
LIST_4xx="$(targets_by_cpu ppc4xx)"
wdenk's avatar
wdenk committed
301 302

#########################################################################
303
## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk's avatar
wdenk committed
304 305
#########################################################################

306
LIST_8260="$(targets_by_cpu mpc8260)"
wdenk's avatar
wdenk committed
307

Eran Liberty's avatar
Eran Liberty committed
308 309 310 311
#########################################################################
## MPC83xx Systems (includes 8349, etc.)
#########################################################################

312
LIST_83xx="$(targets_by_cpu mpc83xx)"
Eran Liberty's avatar
Eran Liberty committed
313

314 315 316 317
#########################################################################
## MPC85xx Systems (includes 8540, 8560 etc.)
#########################################################################

318
LIST_85xx="$(targets_by_cpu mpc85xx)"
319

320 321 322 323
#########################################################################
## MPC86xx Systems
#########################################################################

324
LIST_86xx="$(targets_by_cpu mpc86xx)"
325

326 327 328 329 330 331 332 333 334 335
#########################################################################
## PowerPC groups
#########################################################################

LIST_TSEC="		\
	${LIST_83xx}	\
	${LIST_85xx}	\
	${LIST_86xx}	\
"

336
LIST_powerpc="		\
337
	${LIST_5xx}	\
338
	${LIST_512x}	\
339 340 341 342 343 344 345 346 347
	${LIST_5xxx}	\
	${LIST_8xx}	\
	${LIST_824x}	\
	${LIST_8260}	\
	${LIST_83xx}	\
	${LIST_85xx}	\
	${LIST_86xx}	\
	${LIST_4xx}	\
"
wdenk's avatar
wdenk committed
348

349 350 351 352 353 354
# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
# still using "ppc" instead of "powerpc"
LIST_ppc="		\
	${LIST_powerpc}	\
"

wdenk's avatar
wdenk committed
355 356 357 358
#########################################################################
## StrongARM Systems
#########################################################################

359
LIST_SA="$(targets_by_cpu sa1100)"
wdenk's avatar
wdenk committed
360

361 362 363 364
#########################################################################
## ARM7 Systems
#########################################################################

365
LIST_ARM7="$(targets_by_cpu arm720t)"
366

wdenk's avatar
wdenk committed
367 368 369 370
#########################################################################
## ARM9 Systems
#########################################################################

371 372 373
LIST_ARM9="$(targets_by_cpu arm920t)	\
	$(targets_by_cpu arm926ejs)	\
	$(targets_by_cpu arm946es)	\
374
"
wdenk's avatar
wdenk committed
375

376 377 378
#########################################################################
## ARM11 Systems
#########################################################################
379 380
LIST_ARM11="$(targets_by_cpu arm1136)	\
	$(targets_by_cpu arm1176)	\
381
"
382

383
#########################################################################
384
## ARMV7 Systems
385
#########################################################################
386

387
LIST_ARMV7="$(targets_by_cpu armv7)"
388

389 390 391 392 393 394
#########################################################################
## ARMV8 Systems
#########################################################################

LIST_ARMV8="$(targets_by_cpu armv8)"

395 396 397 398
#########################################################################
## AT91 Systems
#########################################################################

399
LIST_at91="$(targets_by_soc at91)"
400

wdenk's avatar
wdenk committed
401 402 403 404
#########################################################################
## Xscale Systems
#########################################################################

405
LIST_pxa="$(targets_by_cpu pxa)"
wdenk's avatar
wdenk committed
406

407 408 409 410
#########################################################################
## SPEAr Systems
#########################################################################

411
LIST_spear="$(targets_by_soc spear)"
412

413 414 415
#########################################################################
## ARM groups
#########################################################################
416

417 418 419 420 421
LIST_arm="$(targets_by_arch arm |		\
	for ARMV8_TARGET in $LIST_ARMV8;	\
		do sed "/$ARMV8_TARGET/d";	\
	done)					\
"
wdenk's avatar
wdenk committed
422

423
#########################################################################
424
## MIPS Systems		(default = big endian)
425 426
#########################################################################

427
LIST_mips="$(targets_by_arch mips)"
428

429 430 431 432
#########################################################################
## OpenRISC Systems
#########################################################################

433
LIST_openrisc="$(targets_by_arch openrisc)"
434

435
#########################################################################
Graeme Russ's avatar
Graeme Russ committed
436
## x86 Systems
437 438
#########################################################################

439
LIST_x86="$(targets_by_arch x86)"
440

441 442 443 444
#########################################################################
## Nios-II Systems
#########################################################################

445
LIST_nios2="$(targets_by_arch nios2)"
446

447 448 449 450
#########################################################################
## MicroBlaze Systems
#########################################################################

451
LIST_microblaze="$(targets_by_arch microblaze)"
452

453 454 455 456
#########################################################################
## ColdFire Systems
#########################################################################

457
LIST_m68k="$(targets_by_arch m68k)"
458
LIST_coldfire=${LIST_m68k}
459

460 461 462 463
#########################################################################
## AVR32 Systems
#########################################################################

464
LIST_avr32="$(targets_by_arch avr32)"
465

466 467 468 469
#########################################################################
## Blackfin Systems
#########################################################################

470
LIST_blackfin="$(targets_by_arch blackfin)"
471

472 473 474 475
#########################################################################
## SH Systems
#########################################################################

476 477 478
LIST_sh2="$(targets_by_cpu sh2)"
LIST_sh3="$(targets_by_cpu sh3)"
LIST_sh4="$(targets_by_cpu sh4)"
479

480
LIST_sh="$(targets_by_arch sh)"
481

482 483 484 485
#########################################################################
## SPARC Systems
#########################################################################

486
LIST_sparc="$(targets_by_arch sparc)"
wdenk's avatar
wdenk committed
487

488 489 490 491
#########################################################################
## NDS32 Systems
#########################################################################

492
LIST_nds32="$(targets_by_arch nds32)"
493

494 495 496 497 498 499
#########################################################################
## ARC Systems
#########################################################################

LIST_arc="$(targets_by_arch arc)"

wdenk's avatar
wdenk committed
500 501
#-----------------------------------------------------------------------

502 503 504 505 506 507 508 509
get_target_location() {
	local target=$1
	local BOARD_NAME=""
	local CONFIG_NAME=""
	local board=""
	local vendor=""

	# Automatic mode
510
	local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
511 512 513 514
	if [ -z "${line}" ] ; then echo "" ; return ; fi

	set ${line}

515
	CONFIG_NAME="${7%_defconfig}"
516

517
	[ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
518

519 520 521 522 523 524
	if [ $# -gt 5 ]; then
		if [ "$6" = "-" ] ; then
			board=${BOARD_NAME}
		else
			board="$6"
		fi
525 526 527
	fi

	[ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
528 529
	[ $# -gt 6 ] && [ "$8" != "-" ] && {
		tmp="${8%:*}"
530 531 532 533 534 535
		if [ "$tmp" ] ; then
			CONFIG_NAME="$tmp"
		fi
	}

	# Assign board directory to BOARDIR variable
536
	if [ "${vendor}" == "-" ] ; then
537 538 539 540 541
	    BOARDDIR=${board}
	else
	    BOARDDIR=${vendor}/${board}
	fi

542
	echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
543 544 545
}

get_target_maintainers() {
546
	local name=`echo $1 | cut -d : -f 3`
547

548
	local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
549
	if [ -z "${line}" ]; then
550 551 552 553
		echo ""
		return ;
	fi

554 555 556
	local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
	[ "$mails" == "-" ] && mails=""
	echo "$mails"
557 558
}

559 560 561
get_target_arch() {
	local target=$1

562
	awk '$7 == "'$target'" { print $2 }' boards.cfg
563 564
}

565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600
list_target() {
	if [ "$PRINT_MAINTS" != 'y' ] ; then
		echo "$1"
		return
	fi

	echo -n "$1:"

	local loc=`get_target_location $1`

	if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi

	local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`

	if [ "$MAINTAINERS_ONLY" != 'y' ] ; then

		local dir=`echo ${loc} | cut -d ":" -f 2`
		local cfg=`echo ${loc} | cut -d ":" -f 1`
		local git_result=`git log --format=%aE board/${dir} \
				include/configs/${cfg}.h | grep "@"`
		local git_result_recent=`echo ${git_result} | tr " " "\n" | \
						head -n 3`
		local git_result_top=`echo ${git_result} | tr " " "\n" | \
			sort | uniq -c | sort -nr | head -n 3 | \
			sed "s/^ \+[0-9]\+ \+//"`

		echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
			sort -u | tr "\n" " " | sed "s/ $//" ;
	else
		echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
						sed "s/ $//" ;
	fi

	echo ""
}

601 602 603 604 605 606 607 608
# Each finished build will have a file called ${donep}${n},
# where n is the index of the build. Each build
# we've already noted as finished will have ${skipp}${n}.
# The code managing the build process will use this information
# to ensure that only BUILD_NBUILDS builds are in flight at once
donep="${LOG_DIR}/._done_"
skipp="${LOG_DIR}/._skip_"

609 610 611 612 613 614 615
build_target_killed() {
	echo "Aborted $target build."
	# Remove the logs for this board since it was aborted
	rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
	exit
}

wdenk's avatar
wdenk committed
616 617
build_target() {
	target=$1
618 619
	build_idx=$2

620 621 622 623 624
	if [ "$ONLY_LIST" == 'y' ] ; then
		list_target ${target}
		return
	fi

625 626 627
	if [ $BUILD_MANY == 1 ] ; then
		output_dir="${OUTPUT_PREFIX}/${target}"
		mkdir -p "${output_dir}"
628
		trap build_target_killed TERM
629 630 631 632
	else
		output_dir="${OUTPUT_PREFIX}"
	fi

633
	target_arch=$(get_target_arch ${target})
634
	eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
635
	if [ "${cross_toolchain}" ] ; then
636
	    MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
637
	elif [ "${CROSS_COMPILE}" ] ; then
638
	    MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
639
	else
640
	    MAKE=$GNU_MAKE
641 642
	fi

643 644 645 646
	if [  "${output_dir}" != "." ] ; then
		MAKE="${MAKE} O=${output_dir}"
	fi

647
	${MAKE} mrproper >/dev/null
648 649 650

	echo "Building ${target} board..."
	${MAKE} -s ${target}_defconfig >/dev/null
651

652
	${MAKE} ${JOBS} ${CHECK} all \
653
		>${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
Peter Tyser's avatar
Peter Tyser committed
654 655 656 657 658 659

	# Check for 'make' errors
	if [ ${PIPESTATUS[0]} -ne 0 ] ; then
		RC=1
	fi

660 661 662 663 664 665 666
	OBJS=${output_dir}/u-boot
	if [ -e ${output_dir}/spl/u-boot-spl ]; then
		OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
	fi

	${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG

667
	if [ $BUILD_MANY == 1 ] ; then
668 669
		trap - TERM

670
		${MAKE} -s clean
671 672

		if [ -s ${LOG_DIR}/${target}.ERR ] ; then
673
			cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
674 675 676
		else
			rm ${LOG_DIR}/${target}.ERR
		fi
677
	else
678
		if [ -s ${LOG_DIR}/${target}.ERR ] ; then
679 680 681 682 683 684 685
			if grep -iw error ${LOG_DIR}/${target}.ERR ; then
				: $(( ERR_CNT += 1 ))
				ERR_LIST="${ERR_LIST} $target"
			else
				: $(( WRN_CNT += 1 ))
				WRN_LIST="${WRN_LIST} $target"
			fi
686 687 688
		else
			rm ${LOG_DIR}/${target}.ERR
		fi
689 690
	fi

691 692 693
	[ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"

	touch "${donep}${build_idx}"
wdenk's avatar
wdenk committed
694
}
695 696 697

manage_builds() {
	search_idx=${OLDEST_IDX}
698 699
	if [ "$ONLY_LIST" == 'y' ] ; then return ; fi

700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724
	while true; do
		if [ -e "${donep}${search_idx}" ] ; then
			: $(( CURRENT_CNT-- ))
			[ ${OLDEST_IDX} -eq ${search_idx} ] &&
				: $(( OLDEST_IDX++ ))

			# Only want to count it once
			rm -f "${donep}${search_idx}"
			touch "${skipp}${search_idx}"
		elif [ -e "${skipp}${search_idx}" ] ; then
			[ ${OLDEST_IDX} -eq ${search_idx} ] &&
				: $(( OLDEST_IDX++ ))
		fi
		: $(( search_idx++ ))
		if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
			if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
				search_idx=${OLDEST_IDX}
				sleep 1
			else
				break
			fi
		fi
	done
}

725 726 727 728 729 730 731 732 733 734 735 736
build_targets() {
	for t in "$@" ; do
		# If a LIST_xxx var exists, use it.  But avoid variable
		# expansion in the eval when a board name contains certain
		# characters that the shell interprets.
		case ${t} in
			*[-+=]*) list= ;;
			*)       list=$(eval echo '${LIST_'$t'}') ;;
		esac
		if [ -n "${list}" ] ; then
			build_targets ${list}
		else
737 738 739 740
			: $((TOTAL_CNT += 1))
			: $((CURRENT_CNT += 1))
			rm -f "${donep}${TOTAL_CNT}"
			rm -f "${skipp}${TOTAL_CNT}"
741 742 743 744 745 746
			if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
				: $((SKIP_CNT += 1))
				touch "${donep}${TOTAL_CNT}"
			elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
				: $((SKIP_CNT += 1))
				touch "${donep}${TOTAL_CNT}"
747
			else
748 749 750 751 752 753 754
				if [ $BUILD_MANY == 1 ] ; then
					build_target ${t} ${TOTAL_CNT} &
				else
					CUR_TGT="${t}"
					build_target ${t} ${TOTAL_CNT}
					CUR_TGT=''
				fi
755
			fi
756 757 758 759 760 761 762 763 764 765 766 767 768 769 770
		fi

		# We maintain a running count of all the builds we have done.
		# Each finished build will have a file called ${donep}${n},
		# where n is the index of the build. Each build
		# we've already noted as finished will have ${skipp}${n}.
		# We track the current index via TOTAL_CNT, and the oldest
		# index. When we exceed the maximum number of parallel builds,
		# We look from oldest to current for builds that have completed,
		# and update the current count and oldest index as appropriate.
		# If we've gone through the entire list, wait a second, and
		# reprocess the entire list until we find a build that has
		# completed
		if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
			manage_builds
771 772 773
		fi
	done
}
wdenk's avatar
wdenk committed
774 775 776

#-----------------------------------------------------------------------

777
kill_children() {
778 779 780 781 782 783 784 785 786 787 788 789 790 791
	local OS=$(uname -s)
	local children=""
	case "${OS}" in
		"Darwin")
			# Mac OS X is known to have BSD style ps
			local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
			children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
			;;
		*)
			# everything else tries the GNU style
			local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
			children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
			;;
	esac
792 793 794

	kill $children 2> /dev/null
	wait $children 2> /dev/null
795 796 797 798

	exit
}

799
print_stats() {
800
	if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
801

802 803 804
	# Only count boards that completed
	: $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))

805 806 807
	rm -f ${donep}* ${skipp}*

	if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
808
		ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
809 810
		ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
		ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
811
		WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
812 813
		WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
		WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
814 815 816
	else
		# Remove the logs for any board that was interrupted
		rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
817 818
	fi

819
	: $((TOTAL_CNT -= ${SKIP_CNT}))
820 821
	echo ""
	echo "--------------------- SUMMARY ----------------------------"
822 823 824
	if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
		echo "Boards skipped: ${SKIP_CNT}"
	fi
825 826
	echo "Boards compiled: ${TOTAL_CNT}"
	if [ ${ERR_CNT} -gt 0 ] ; then
827 828 829 830
		echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
	fi
	if [ ${WRN_CNT} -gt 0 ] ; then
		echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
831 832
	fi
	echo "----------------------------------------------------------"
Peter Tyser's avatar
Peter Tyser committed
833

834
	if [ $BUILD_MANY == 1 ] ; then
835
		kill_children
836 837
	fi

Simon Glass's avatar
Simon Glass committed
838 839
	deprecation

Peter Tyser's avatar
Peter Tyser committed
840
	exit $RC
841
}
wdenk's avatar
wdenk committed
842

843
#-----------------------------------------------------------------------
844

845 846 847
# Build target groups selected by options, plus any command line args
set -- ${SELECTED} "$@"
# run PowerPC by default
848 849
[ $# = 0 ] && set -- powerpc
build_targets "$@"
850
wait